description: '
  DEMO stack (i.e. demoStack1).
  '
heat_template_version: '2013-05-23'
outputs:
  node1.demoStack1:
    description: VM UUID
    value: {get_resource: node1.demoStack1}
  node1.demoStack1-test-port:
    description: Address for interface node1.demoStack1-test-port
    value:
      get_attr: [node1.demoStack1-test-port, fixed_ips, 0, ip_address]
  node1.demoStack1-test-port-device_id:
    description: Device ID for interface node1.demoStack1-test-port
    value:
      get_attr: [node1.demoStack1-test-port, device_id]
  node1.demoStack1-test-port-mac_address:
    description: MAC Address for interface node1.demoStack1-test-port
    value:
      get_attr: [node1.demoStack1-test-port, mac_address]
  node1.demoStack1-test-port-network_id:
    description: Network ID for interface node1.demoStack1-test-port
    value:
      get_attr: [node1.demoStack1-test-port, network_id]
  node1.demoStack1-test-port-subnet_id:
    description: Address for interface node1.demoStack1-test-port
    value:
      get_attr: [node1.demoStack1-test-port, fixed_ips, 0, subnet_id]
  node2.demoStack1:
    description: VM UUID
    value: {get_resource: node2.demoStack1}
  node2.demoStack1-fip:
    description: floating ip node2.demoStack1-fip
    value:
      get_attr: [node2.demoStack1-fip, fixed_ip_address]
  node2.demoStack1-test-port:
    description: Address for interface node2.demoStack1-test-port
    value:
      get_attr: [node2.demoStack1-test-port, fixed_ips, 0, ip_address]
  node2.demoStack1-test-port-device_id:
    description: Device ID for interface node2.demoStack1-test-port
    value:
      get_attr: [node2.demoStack1-test-port, device_id]
  node2.demoStack1-test-port-mac_address:
    description: MAC Address for interface node2.demoStack1-test-port
    value:
      get_attr: [node2.demoStack1-test-port, mac_address]
  node2.demoStack1-test-port-network_id:
    description: Network ID for interface node2.demoStack1-test-port
    value:
      get_attr: [node2.demoStack1-test-port, network_id]
  node2.demoStack1-test-port-subnet_id:
    description: Address for interface node2.demoStack1-test-port
    value:
      get_attr: [node2.demoStack1-test-port, fixed_ips, 0, subnet_id]
  demoStack1-secgroup:
    description: ID of Security Group
    value: {get_resource: demoStack1-secgroup}
  demoStack1-test-subnet:
    description: subnet demoStack1-test-subnet ID
    value: {get_resource: demoStack1-test-subnet}
  demoStack1-test-subnet-cidr:
    description: subnet demoStack1-test-subnet cidr
    value:
      get_attr: [demoStack1-test-subnet, cidr]
  demoStack1-test-subnet-gateway_ip:
    description: subnet demoStack1-test-subnet gateway_ip
    value:
      get_attr: [demoStack1-test-subnet, gateway_ip]
resources:
  node1.demoStack1:
    depends_on: [demoStack1-key, node1.demoStack1-test-port]
    properties:
      admin_user: ubuntu
      config_drive: true
      flavor: m1.tiny
      image: cirros-0.3.5
      key_name: {get_resource: demoStack1-key}
      name: node1.demoStack1
      networks:
      - port: {get_resource: node1.demoStack1-test-port}
    type: OS::Nova::Server
  node1.demoStack1-test-port:
    depends_on: [demoStack1-test-subnet, demoStack1-secgroup]
    properties:
      binding:vnic_type: normal
      fixed_ips:
      - subnet: {get_resource: demoStack1-test-subnet}
      name: node1.demoStack1-test-port
      network: {get_resource: demoStack1-test}
      security_groups: [demoStack1-secgroup]
    type: OS::Neutron::Port
  node2.demoStack1:
    depends_on: [demoStack1-key, node2.demoStack1-test-port]
    properties:
      admin_user: ubuntu
      config_drive: true
      flavor: m1.tiny
      image: cirros-0.3.5
      key_name: {get_resource: demoStack1-key}
      name: node2.demoStack1
      networks:
      - port: {get_resource: node2.demoStack1-test-port}
      scheduler_hints:
        different_host: {get_resource: node1.demoStack1}
    type: OS::Nova::Server
  node2.demoStack1-fip:
    depends_on: [node2.demoStack1-test-port, demoStack1-test-router-if0, demoStack1-secgroup]
    properties:
      floating_ip_address: 192.168.11.33
      floating_network: public
      port_id: {get_resource: node2.demoStack1-test-port}
    type: OS::Neutron::FloatingIP
  node2.demoStack1-fip-assoc:
    depends_on: [node2.demoStack1-test-port]
    properties:
      floatingip_id: {get_resource: node2.demoStack1-fip}
      port_id: {get_resource: node2.demoStack1-test-port}
    type: OS::Neutron::FloatingIPAssociation
  node2.demoStack1-test-port:
    depends_on: [demoStack1-test-subnet, demoStack1-secgroup]
    properties:
      binding:vnic_type: normal
      fixed_ips:
      - subnet: {get_resource: demoStack1-test-subnet}
      name: node2.demoStack1-test-port
      network: {get_resource: demoStack1-test}
      security_groups: [demoStack1-secgroup]
    type: OS::Neutron::Port
  demoStack1-key:
    properties: {name: demoStack1-key, public_key: 'ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAABAQCza7H6/x8Ub13qM9VRVpvjIu62RnnILCOc7+GBa4HFIZu4+pDkJ7uodDUL9C174JcC9sVKznYDeTOqJqDHC6helYETt4sd90mZT6mIIvdTtvi0O7lnMrN9cGLfQCjtBI22qaU3Djz4c1+P2NPlacaPnZUrkivoi1+R5ZVFM2vOqiULOKlQGYUNsQm9C1gOesId7Y0xdl4f1+mcn1m17es9xtzSh/e0E43z4OjX8kXThilsiKXze07C1cXQM17SjbFGfIn72mGzOruOlmgHowgrzSHCdpfWu/uLFv0qVpEHozM0U7BAAxXtx2kRRCUDfAu/5hBSfqX/8R/Jj3/SfdjB Generated-by-Nova'}
    type: OS::Nova::KeyPair
  demoStack1-secgroup:
    properties:
      description: Group allowing IPv4 and IPv6 for icmp and upd/tcp onall ports
      name: demoStack1-secgroup
      rules:
      - {port_range_max: '65535', port_range_min: '1', protocol: tcp, remote_ip_prefix: 0.0.0.0/0}
      - {port_range_max: '65535', port_range_min: '1', protocol: udp, remote_ip_prefix: 0.0.0.0/0}
      - {protocol: icmp, remote_ip_prefix: 0.0.0.0/0}
      - {ethertype: IPv6, port_range_max: '65535', port_range_min: '1', protocol: tcp,
        remote_ip_prefix: '::/0'}
      - {ethertype: IPv6, port_range_max: '65535', port_range_min: '1', protocol: udp,
        remote_ip_prefix: '::/0'}
      - {ethertype: IPv6, protocol: ipv6-icmp, remote_ip_prefix: '::/0'}
      - {direction: egress, port_range_max: '65535', port_range_min: '1', protocol: tcp,
        remote_ip_prefix: 0.0.0.0/0}
      - {direction: egress, port_range_max: '65535', port_range_min: '1', protocol: udp,
        remote_ip_prefix: 0.0.0.0/0}
      - {direction: egress, protocol: icmp, remote_ip_prefix: 0.0.0.0/0}
      - {direction: egress, ethertype: IPv6, port_range_max: '65535', port_range_min: '1',
        protocol: tcp, remote_ip_prefix: '::/0'}
      - {direction: egress, ethertype: IPv6, port_range_max: '65535', port_range_min: '1',
        protocol: udp, remote_ip_prefix: '::/0'}
      - {direction: egress, ethertype: IPv6, protocol: ipv6-icmp, remote_ip_prefix: '::/0'}
    type: OS::Neutron::SecurityGroup
  demoStack1-test:
    properties: {name: demoStack1-test}
    type: OS::Neutron::Net
  demoStack1-test-router:
    depends_on: [demoStack1-test-subnet]
    properties:
      external_gateway_info: {network: public}
      name: demoStack1-test-router
    type: OS::Neutron::Router
  demoStack1-test-router-if0:
    depends_on: [demoStack1-test-router, demoStack1-test-subnet]
    properties:
      router_id: {get_resource: demoStack1-test-router}
      subnet_id: {get_resource: demoStack1-test-subnet}
    type: OS::Neutron::RouterInterface
  demoStack1-test-subnet:
    depends_on: demoStack1-test
    properties:
      cidr: 10.0.1.0/24
      enable_dhcp: 'true'
      name: demoStack1-test-subnet
      network_id: {get_resource: demoStack1-test}
      dns_nameservers: [ "192.168.11.3", "8.8.4.4" ]
    type: OS::Neutron::Subnet